<?php
/**
 * Zone list page
 * @author oneTarek
 * @since 2.0.0
 */

// Don't allow direct access
if( ! defined( 'ABSPATH' ) ) exit;

require_once ADGURU_PLUGIN_DIR . 'includes/admin/class-adguru-zone-list-table.php';
$args = array(
	'singular' => __("zone", "adguru"),
	'plural'   => __("zones", "adguru"),
	'base_url' => $base_url
);
$zone_list_table = new ADGURU_Zone_List_Table( $args );
$zone_list_table->prepare_items();
?>
	
<form id="adguru-zone-search-form" method="get" action="<?php echo $base_url; ?>" style="margin-top:5px;">
	<?php $zone_list_table->search_box( __( 'Search', 'adguru' ), 'adguru_zone_search_input' ); ?>

	<input type="hidden" name="manager_tab" value="<?php echo $current_manager_tab ?>" />
	<input type="hidden" name="page" value="<?php echo $page ?>" />
	
	<?php $zone_list_table->views() ?>
	<?php $zone_list_table->display() ?>
</form>

<style type="text/css">
	.wp-list-table .column-ID{ width:5%; }
</style>

<!-- Start Get Code Modal -->
<div id="zone_code_modal" title="Get Code">
	<div id="zone_code_content">
			<strong><?php _e( 'PHP CODE', 'adguru' ) ?></strong><BR />
			<code id="zone_code_php">	</code><BR /><BR />
			<strong><?php _e( 'SHORTCODE', 'adguru' ) ?></strong><BR />
			<code id="zone_code_shortcode"></code>
		<!--content will be generated by javascript-->
	</div>			
</div>
<script type="text/javascript">
	jQuery(document).ready(function($) {
		
		$( "#zone_code_modal" ).dialog({
			height: 230,
			width: 600,
			modal: true,
			autoOpen: false,
			buttons: {
				Cancel: function() {$( this ).dialog( "close" );}
				}		
		});//END DIALOG				
		
	});//end document ready

	function show_zone_code_modal(zoneid , name)
	{
		var php_code="&lt;?php if(function_exists('adguru_zone')){adguru_zone("+zoneid+");} ?&gt;";
		var shortcode='[adguru zoneid="'+zoneid+'"]';
		jQuery("#zone_code_php").html(php_code);
		jQuery("#zone_code_shortcode").html(shortcode);
		jQuery( "#zone_code_modal" ).dialog( { title: "Get Code for : "+name });
		jQuery( "#zone_code_modal" ).dialog( "open" );
		return false;
	}
</script>
<!-- End Get Code Modal -->


