<?php

// Don't allow direct access
if ( ! defined( 'ABSPATH' ) ) exit;

if( wp_get_referer() && isset( $_GET['msg'] ) && $_GET['msg'] != "" )
{
	if( $_GET['msg'] == "deleted")
	{
		adguru()->admin_notice->render( "Theme has been deleted successfully", array( "type"=>"success", "dismissible"=>true ) );
	}
}

require_once ( dirname(__FILE__) . '/class-adguru-modal-popup-theme-list-table.php' );
$args = array(
	'singular' => __("Modal Popup Theme", "adguru"),
	'plural'   => __("Modal Popup Themes", "adguru"),
	'base_url' => $base_url
);

$theme_list_table = new ADGURU_Modal_Popup_Theme_List_Table( $args );
$theme_list_table->prepare_items();

?>		
<form id="adguru-ad-search-form" method="get" action="<?php echo $base_url; ?>" style="margin-top:5px;">
	<?php $theme_list_table->search_box( __( 'Search', 'adguru' ), 'adguru_ad_search_input' ); ?>

	<input type="hidden" name="manager_tab" value="<?php echo $current_manager_tab ?>" />
	<input type="hidden" name="page" value="<?php echo $page ?>" />
	

	<?php $theme_list_table->views() ?>
	<?php $theme_list_table->display() ?>
	
</form>

<div style="margin-top:50px;">
	<input type="button" class="button-primary adguru-button" value="<?php echo esc_attr( __( 'Import Theme', 'adguru' ) ) ?>" onclick="show_theme_import_modal()" style="height:40px; font-size:20px;line-height:20px;">
</div>


<style type="text/css">
	.wp-list-table .column-ID{ width:5%; }
</style>

<script type="text/javascript">
	function enable_modal_button( btn_text )
	{
		jQuery(".ui-dialog-buttonpane button:contains('"+btn_text+"')").button('enable');
	}

	function disable_modal_button( btn_text )
	{
		jQuery(".ui-dialog-buttonpane button:contains('"+btn_text+"')").button('disable');
	}
</script>

<!-- Start Theme Export Modal -->
<div id="theme_export_modal" title="Export Theme Data">
	<div id="theme_export_content">
			<?php _e( 'Copy following theme data', 'adguru' ) ?><BR />
			<div id="theme_export_loading_box" class="hidden"><?php _e( 'Loading theme data', 'adguru' ) ?>...</div>
			<textarea id="theme_export_data" class="hidden" readonly></textarea>
		<!--content will generated by javascript-->
	</div>			
</div>
<style type="text/css">
	#theme_export_loading_box{
		height: 180px;
		padding: 20px;
		padding-top:100px;
		background: #eeeeee;
		color:#cccccc;
		font-size: 40px;
		line-height: 40px;
	}
	#theme_export_data{
		width: 100%;
		height: 300px;
		overflow: scroll;
	}

</style>
<script type="text/javascript">
	jQuery(document).ready(function($){
		
		$( "#theme_export_modal" ).dialog({
			height: 440,
			width: 600,
			modal: true,
			autoOpen: false,
			buttons: {
				'Copy Data': function(){ $('#theme_export_data').select(); document.execCommand("copy"); },
				Cancel: function() {$( this ).dialog( "close" );},

			},
			open: function()
		    {
		        disable_modal_button('Copy Data');
		    }		
		});//END DIALOG
		jQuery( "#theme_export_data" ).click(function(){
			jQuery(this).select();
		});

	}); //end document ready
		
	function show_theme_export_modal(theme_id , name)
	{
		jQuery( "#theme_export_data" ).val("");
		jQuery( "#theme_export_loading_box" ).removeClass('hidden');
		jQuery( "#theme_export_data" ).addClass('hidden');

		jQuery( "#theme_export_modal" ).dialog( { title: "Export Theme : "+name });
		jQuery( "#theme_export_modal" ).dialog( "open" );


		var qData={
			"action"	:	"adguru_mp_get_theme_data", 
			"theme_id"	: 	theme_id
			};
		
		jQuery.ajax({
		   url: adGuruAdminVars.ajaxUrl,
		   type: "GET",
		   global: false,
		   cache: false,
		   async: true,
		   dataType: 'json',
		   data:qData,
			success: function(response){				
				
					jQuery( "#theme_export_loading_box" ).addClass('hidden');
					if(response.status == 'success')
					{
						jQuery( "#theme_export_data" ).val( response.theme_data );
						jQuery( "#theme_export_data" ).removeClass('hidden');
						enable_modal_button('Copy Data');
									
					}
					else
					{
						alert(response.message);
					}
				},
			error: function(xhr,errorThrown){
				jQuery( "#theme_export_loading_box" ).addClass('hidden');
				alert('Something went wrong');
			}
			   
		  });//end $.ajax

		
		return false;
	}			
</script>
<!-- End Theme Export Modal -->

<!-- Start Theme Import Modal -->
<div id="theme_import_modal" title="Import Theme">
	<div id="theme_import_content">
			<?php _e( 'Put theme data below', 'adguru' ) ?><BR />
			<div id="theme_import_loading_box" class="hidden"><?php _e( 'Importing theme data', 'adguru' ) ?>...</div>
			<textarea id="theme_import_data" class="hidden" placeholder="Theme data" ></textarea>
		<!--content will generated by javascript-->
	</div>			
</div>
<style type="text/css">
	#theme_import_loading_box{
		height: 180px;
		padding: 20px;
		padding-top:100px;
		background: #eeeeee;
		color:#cccccc;
		font-size: 40px;
		line-height: 40px;
	}
	#theme_import_data{
		width: 100%;
		height: 300px;
		overflow: scroll;
	}

</style>
<script type="text/javascript">
	jQuery(document).ready(function($){
		
		$( "#theme_import_modal" ).dialog({
			height: 440,
			width: 600,
			modal: true,
			autoOpen: false,
			buttons: {
				'Import theme': function(){ import_theme_data(); },
				Cancel: function() {$( this ).dialog( "close" );},

			},
			open: function()
		    {
		        enable_modal_button('Import theme');
		    }		
		});//END DIALOG
		jQuery( "#theme_import_data" ).change(function(){
			var data = jQuery(this).val();
			if( data != "")
			{
				//enable_modal_button('Import theme');
			}
			else
			{
				//disable_modal_button('Import theme');
			}
		});

	}); //end document ready
	

	function show_theme_import_modal()
	{
		jQuery( "#theme_import_data" ).val("");
		jQuery( "#theme_import_loading_box" ).addClass('hidden');
		jQuery( "#theme_import_data" ).removeClass('hidden');

		jQuery( "#theme_import_modal" ).dialog( { title: "Import Theme" });
		jQuery( "#theme_import_modal" ).dialog( "open" );


		

		
		return false;
	}
	function is_valid_theme_data( theme_data )
	{
		theme_data = jQuery.trim( theme_data );
		if( theme_data == ""){ return false;}
		try 
		{
	        JSON.parse(theme_data);
	    } 
	    catch (e) 
	    {
	        return false;
	    }
	    return true;
	}

	function import_theme_data()
	{
		
		disable_modal_button('Import theme data');
		var theme_data = jQuery( "#theme_import_data" ).val();
		if( ! is_valid_theme_data( theme_data ) )
		{
			alert("Theme data is not valid");
			return false;
		}
		jQuery( "#theme_import_loading_box" ).removeClass('hidden');
		disable_modal_button('Import theme');

		var qData={
			"action"	:	"adguru_mp_import_theme_data", 
			"theme_data"	: 	theme_data
			};
		
		jQuery.ajax({
		   url: adGuruAdminVars.ajaxUrl,
		   type: "POST",
		   global: false,
		   cache: false,
		   async: true,
		   dataType: 'json',
		   data:qData,
			success: function(response){				
				
					jQuery( "#theme_import_loading_box" ).addClass('hidden');
					if(response.status == 'success')
					{
						jQuery( "#theme_import_data" ).val('');
						jQuery( "#theme_import_data" ).removeClass('hidden');
						enable_modal_button('Import theme');

						alert( response.message + ' New theme id : '+response.theme_id );
						jQuery( "#theme_import_modal" ).dialog( "close" );
						//reload page
						location.reload();
									
					}
					else
					{
						alert(response.message);
						enable_modal_button('Import theme');
					}
				},
			error: function(xhr,errorThrown){
				jQuery( "#theme_import_loading_box" ).addClass('hidden');
				alert('Something went wrong.');
				jQuery( "#theme_import_data" ).val('');
				jQuery( "#theme_import_data" ).removeClass('hidden');
				enable_modal_button('Import theme');

			}
			   
		  });//end $.ajax

	}			
</script>
<!-- End Theme Import Modal -->